package com.laihua.projecthelper.code

import com.laihua.projecthelper.implement.belongModule
import com.laihua.projecthelper.implement.belongModuleFile
import com.laihua.projecthelper.unuse.ReadUtil
import java.io.File

/**
 * Author: pengjunjing
 * Date: 2022/3/11
 * Description:
 */
class ProjectCode {

    /**
     * 根据指定的规则,读取项目中的代码文件
     */
    fun readCode(codeReader: CodeReader): MutableSet<Module> {
        //项目根目录路径
        val projectRoot = File("")
        val projectPath = projectRoot.absolutePath
        val projectRootF = File(projectPath)
        val readCodeFile = ReadUtil().readCodeFile(projectRootF)
        val moduleSet = mutableSetOf<Module>()
        //遍历项目里的所有文件
        for (file in readCodeFile) {
            //过滤出需要的代码
            val targetCode: List<String> = codeReader.targetCode(file)
            if (targetCode.isNotEmpty()) {
                //所处模块
                file.belongModule()?.let {
                    if (!moduleSet.containModule(it)) {
                        //添加不存在的模块
                        moduleSet.add(Module(file.belongModuleFile()!!))
                    }

                    //为该模块添加一份代码
                    moduleSet.getModule(it)!!.codes.add(JavaKtXmlCode(file, targetCode))

                }
            }

        }
        return moduleSet

    }


}